import { WebSocketServer } from 'ws';
export async function CreateServer(contract, options) {
    const websocket = new WebSocketServer(options);
    const methods = contract;
    websocket.addListener('connection', client => client.on('message', async (data) => {
        var _a;
        try {
            const request = JSON.parse(data.toString('utf8'));
            const { method, reference, parameters } = request;
            let response;
            try {
                if (method in methods) {
                    const result = (_a = (await methods[method](...parameters))) !== null && _a !== void 0 ? _a : null;
                    response = { type: "callback", reference, result };
                }
                else {
                    throw new Error(`The method '${method}' is not registered!`);
                }
            }
            catch (err) {
                const error = err;
                response = { type: "callback", reference, error: { name: error.name, message: error.message, stack: error.stack } };
            }
            client.send(JSON.stringify(response));
        }
        catch (error) {
        }
    }));
    return websocket;
}
